
// ----- ȒPȃNX
// O[oV{
// ::puts( object )
//   object  print čŌɉso
//
// BMX2WAV e[u
//   BMX2WAV ̊ef[^pe[u
//   Xbg
//     system( string ) -> integer
//       悭 system ֐A̋NvZX̕Wo͂eƓɂȂ
//
//     integer_to_word_string( integer ) -> string
//        BMS  Wordi36ij̕ɕϊi 17 -> "0F",  42 -> "16" j
//
//     word_string_to_integer( string ) -> integer
//       BMS  Wordi36ij̕񂩂琮ɕϊB擪2Ȃ̂ŒӁi "0F" -> 17, "16" -> 42 j
//
//     Path -> table
//       basename( string ) -> string
//       dirname( string ) -> string
//       change_extension( string, string ) -> string
//
// Searcher e[u
//   BMX2WAV Searcher ̊ef[^pe[u
//   Xbg
//     display_filters -> array
//       fBXvCtB^f[^p̔z
//
//     column_groups -> array
//       JO[vp̔z
//
// Entry NX
//   t@C1ɑΉNX
//   e֐̈Ŏg
//   static Xbg
//     compare( entry, entry ) -> intger
//   Xbg
//     path -> string
//     display_name -> string
//     type_name -> string
//     parse_as_bms_data()
//     parse_as_bms_data_once()
//     search_hit -> boolean
//     bms_data -> BmsData NX
//
// BmsData NX
//   BMSƂẴf[^\NX
//   Xbg
//     headers -> table
//       wb_ bms_data.headers["TITLE"] ƂŎ擾
//     path -> string
//     object_count -> integer
//     object_count_of_1P -> integer
//     object_count_of_2P -> integer
//     has_random_statement -> boolean
//     calculate_playing_time -> float
//
// MessageBox e[u
//   bZ[W{bNX\֐Q
//   ʓ|̂ŎgpƈꗗĎ
//   gp1
//     MessageBox.Ok( "bZ[W", "LvV", MessageBox.Icon.INFORMATION );
//   gp2
//     local result = MessageBox.YesNo( "bZ[W", "LvV", MessageBox.Icon.QUESTION );
//     if ( result == MessageBox.Result.YES ) {
//
//   Xbgꗗ
//     bZ[W{bNXĂяo֐Q
//     ͑S( message, caption, icon )Ŗ߂l Resultiqĵǂꂩ
//       Ok
//       OkCancel
//       RetryCancel
//       YesNo
//       YesNoCancel
//       AbortRetryIgnore
//
//     Icon e[u
//       NONE
//       EXCLAMATION
//       WARNING
//       INFORMATION
//       ASTERISK
//       QUESTION
//       STOP
//       ERROR
//       HAND
//
//     Result e[u
//       ABORT
//       CANCEL
//       IGNORE
//       NO
//       OK
//       RETRY
//       YES
//
//     DefaultButton e[u
//       FIRST
//       SECOND
//       THIRD
//       FOURTH
//



// ----- Display Filter ֘A ---------------------------------------------
// -- DisplayFilter
class DisplayFilter {
  constructor( name ) {
    this.name = name;
  }

  function filtering( entry ) {
    return true;
  }

  name = null;
};

// -- AllPassFilter
class AllPassFilter extends DisplayFilter {
  constructor() {
    base.constructor( "Sĕ\" );
  }

  function filtering( entry ) {
    return true;
  }
};

// -- ExtensionsFilter
class ExtensionsFilter extends DisplayFilter {
  constructor( name, ... ) {
    base.constructor( name );
    this.extensions = []
      for ( local i = 0; i < vargv.len(); i++ ) {
        this.extensions.append( vargv[i] );
      }
  }

  function filtering( entry ) {
    local low_path = entry.path.tolower();
    foreach ( extension in this.extensions ) {
      if ( ::endswith( low_path, "." + extension ) ) {
        return true;
      }
    }
    return false;
  }

  extensions = null;
};


// ----- ColumnGroup ֘A ------------------------------------------------
function safety_get( table, key, default_value ) {
  return ( key in table ) ? table[key] : default_value;
}

// -- Column
class Column {
  constructor( name ) {
    this.name = name;
  }

  function display_cell( entry ) {
    return "-";
  }

  function compare( entry_x, entry_y ) {
    return ::Entry.compare( entry_x, entry_y );
  }

  function string_compare( str_x, str_y ) {
    if ( str_x == "" ) {
      return str_y == "" ? 0 : 1;
    }
    if ( str_y == "" ) {
      return -1;
    }
    return str_x <=> str_y;
  }

  name = null;
};

// -- HeaderColumn
class HeaderColumn extends Column {
  constructor( header_name, ... ) {
    base.constructor( "#" + header_name );
    this.header_name = header_name;
    this.compare_function = HeaderColumn.compare_as_string;
    if ( vargv.len() > 0 ) {
      this.compare_function = vargv[0];
    }
  }

  function display_cell( entry ) {
    return ::safety_get( entry.bms_data.headers, this.header_name, "-" );
  }

  function compare( x, y ) {
    return this.compare_function( x, y );
  }

  function compare_as_integer_asc( x, y ) {
    local x_value = ::safety_get( x.bms_data.headers, this.header_name, "" );
    local y_value = ::safety_get( y.bms_data.headers, this.header_name, "" );
    if ( x_value == "" ) {
      return y_value == "" ? 0 : 1;
    }
    if ( y_value == "" ) {
      return -1;
    }
    return x_value.tointeger() <=> y_value.tointeger();
  }

  function compare_as_integer_desc( x, y ) {
    local x_value = ::safety_get( x.bms_data.headers, this.header_name, "" );
    local y_value = ::safety_get( y.bms_data.headers, this.header_name, "" );
    if ( x_value == "" ) {
      return y_value == "" ? 0 : 1;
    }
    if ( y_value == "" ) {
      return -1;
    }
    return y_value.tointeger() <=> x_value.tointeger();
  }

  function compare_as_string( x, y ) {
    local x_value = ::safety_get( x.bms_data.headers, this.header_name, "" );
    local y_value = ::safety_get( y.bms_data.headers, this.header_name, "" );
    return this.string_compare( x_value, y_value );
  }

  header_name = null;
  compare_function = null
  }

// -- PlayerColumn
class PlayerColumn extends HeaderColumn {
  constructor() {
    base.constructor( "PLAYER", HeaderColumn.compare_as_integer_asc );
  }

  function display_cell( entry ) {
    local tmp = base.display_cell( entry );
    switch ( tmp ) {
    case "1": return "1P";
    case "2": return "2P";
    case "3": return "DP";
    case "4": return "Battle Play";
    default:  return tmp;
    }
  }
}

// -- ObjectCountColumn
class ObjectCountColumn extends Column {
  constructor() {
    base.constructor( "IuWFNg" );
  }

  function display_cell( entry ) {
    return entry.bms_data.object_count;
  }

  function compare( x, y ) {
    return y.bms_data.object_count <=> x.bms_data.object_count;
  }
}

// -- ObjectOf1PCountColumn
class ObjectOf1PCountColumn extends Column {
  constructor() {
    base.constructor( "1PIuWFNg" );
  }

  function display_cell( entry ) {
    return entry.bms_data.object_count_of_1P;
  }

  function compare( x, y ) {
    return y.bms_data.object_count_of_1P <=> x.bms_data.object_count_of_1P;
  }
}

// -- ObjectOf2PCountColumn
class ObjectOf2PCountColumn extends Column {
  constructor() {
    base.constructor( "2PIuWFNg" );
  }

  function display_cell( entry ) {
    return entry.bms_data.object_count_of_2P;
  }

  function compare( x, y ) {
    return y.bms_data.object_count_of_2P <=> x.bms_data.object_count_of_2P;
  }
}

// -- ContainsRandomStatementColumn
class ContainsRandomStatementColumn extends Column {
  constructor() {
    base.constructor( "_\" );
  }

  function display_cell( entry ) {
    return entry.bms_data.has_random_statement ? "L" : "";
  }

  function compare( x, y ) {
    return (y.bms_data.has_random_statement ? 1 : 0) <=> (x.bms_data.has_random_statement ? 1 : 0);
  }
}

// -- FullPathColumn
class FullPathColumn extends Column {
  constructor() {
    base.constructor( "pX" );
  }

  function display_cell( entry ) {
    return entry.path;
  }

  function compare( x, y ) {
    return this.string_compare( x.path, y.path );
  }
}

// -- ParentDirectoryColumn
class ParentDirectoryColumn extends Column {
  constructor() {
    base.constructor( "tH_" );
  }

  function get_parent_directory( entry ) {
    return BMX2WAV.Path.basename( BMX2WAV.Path.dirname( entry.path ) );
  }

  function display_cell( entry ) {
    return this.get_parent_directory( entry );
  }

  function compare( x, y ) {
    return this.string_compare( this.get_parent_directory( x ), this.get_parent_directory( y ) );
  }
}

// -- ParentsParentDirectoryColumn
class ParentsParentDirectoryColumn extends Column {
  constructor() {
    base.constructor( "etH_" );
  }

  function get_parents_parent_directory( entry ) {
    return BMX2WAV.Path.basename( BMX2WAV.Path.dirname( BMX2WAV.Path.dirname( entry.path ) ) );
  }

  function display_cell( entry ) {
    return this.get_parents_parent_directory( entry );
  }

  function compare( x, y ) {
    return this.string_compare( this.get_parents_parent_directory( x ), this.get_parents_parent_directory( y ) );
  }
}

// -- PlayingTimeColumn
class PlayingTimeColumn extends Column {
  constructor() {
    base.constructor( "t" );
  }

  function display_cell( entry ) {
    local tmp = entry.bms_data.calculate_playing_time();
    local minute = (tmp / 60.0).tointeger();
    local second = (tmp - 60.0 * minute.tofloat()).tointeger();
    return format( "%d:%02d", minute, second );
  }

  function compare( x, y ) {
    return x.bms_data.calculate_playing_time() <=> y.bms_data.calculate_playing_time();
  }
}


// -- ColumnGroup
class ColumnGroup {
  constructor( name ) {
    this.name = name;
    this.columns = [];
  }

  name = null;
  columns = null;
};


// ----- SearchMethod ֘A -----------------------------------------------
class SearchMethod {
  constructor( name ) {
    this.name = name;
  }

  function search( entry ) {
    return true;
  }

  function by_each_directory( entry_array ) {
    // tH_ɌĂяo֐
    // search  true ɂȂ entry ̔z entry_array
    // entry.search_hitiftHgtruej false ɂƃXgɓȂ
  }

  name = null;
};

// -- BmsAllSearchMethod
class BmsAllSearchMethod extends SearchMethod {
  constructor() {
    base.constructor( "BMSnʑS" );
  }

  function search( entry ) {
    return this.filter.filtering( entry );
  }

  filter = ExtensionsFilter( "BMSn", "bms", "bme", "bml", "pms" );
}

// -- MostPlaylevelSearchMethod
class MostPlaylevelSearchMethod extends SearchMethod {
  constructor() {
    base.constructor( "BMSnitH_Playlevelő̂݁j" );
  }

  function search( entry ) {
    return this.filter.filtering( entry );
  }

  function by_each_directory( entry_array ) {
    local key = "PLAYLEVEL";
    local current = null;
    foreach ( entry in entry_array ) {
      entry.parse_as_bms_data_once();

      if ( key in entry.bms_data.headers ) {
        if ( current == null ) {
          current = entry;
        }
        else if ( current.bms_data.headers[key].tointeger() > entry.bms_data.headers[key].tointeger() ) {
          entry.search_hit = false;
        }
        else {
          current.search_hit = false;
          current = entry;
        }
      }
    }
  }

  filter = ExtensionsFilter( "BMSn", "bms", "bme", "bml", "pms" );
}
