
// ----- Display Filter ֘A ---------------------------------------------
::Searcher.display_filters.append( ExtensionsFilter( "BMSn", "bms", "bme", "bml", "pms" ) );
::Searcher.display_filters.append( ExtensionsFilter( "BMŜ", "bms" ) );
::Searcher.display_filters.append( ExtensionsFilter( "BMÊ", "bme" ) );
::Searcher.display_filters.append( AllPassFilter() );


// ----- ColumnGroup ֘A ------------------------------------------------
{
  local group = ColumnGroup( "Ȉ" );
  group.columns.append( PlayerColumn() );
  group.columns.append( HeaderColumn( "PLAYLEVEL", HeaderColumn.compare_as_integer_desc ) );
  group.columns.append( HeaderColumn( "TITLE", HeaderColumn.compare_as_string ) );
  group.columns.append( HeaderColumn( "ARTIST", HeaderColumn.compare_as_string ) );
  ::Searcher.column_groups.append( group );
}

{
  local group = ColumnGroup( "ڍ" );
  group.columns.append( PlayerColumn() );
  group.columns.append( HeaderColumn( "PLAYLEVEL", HeaderColumn.compare_as_integer_desc ) );
  group.columns.append( HeaderColumn( "TITLE", HeaderColumn.compare_as_string ) );
  group.columns.append( HeaderColumn( "ARTIST", HeaderColumn.compare_as_string ) );
  group.columns.append( HeaderColumn( "GENRE", HeaderColumn.compare_as_string ) );
  group.columns.append( HeaderColumn( "BPM", HeaderColumn.compare_as_integer_asc ) );
  group.columns.append( PlayingTimeColumn() );
  ::Searcher.column_groups.append( group );
}

{
  local group = ColumnGroup( "FX" );
  group.columns.append( PlayerColumn() );
  group.columns.append( HeaderColumn( "TITLE", HeaderColumn.compare_as_string ) );
  group.columns.append( HeaderColumn( "ARTIST", HeaderColumn.compare_as_string ) );
  group.columns.append( ObjectCountColumn() );
  group.columns.append( ObjectOf1PCountColumn() );
  group.columns.append( ObjectOf2PCountColumn() );
  group.columns.append( ContainsRandomStatementColumn() );
  group.columns.append( ParentDirectoryColumn() );
  group.columns.append( ParentsParentDirectoryColumn() );
  group.columns.append( FullPathColumn() );
  ::Searcher.column_groups.append( group );
}

{
  local group = ColumnGroup( "T[`p" );
  group.columns.append( ParentDirectoryColumn() );
  group.columns.append( PlayerColumn() );
  group.columns.append( HeaderColumn( "PLAYLEVEL", HeaderColumn.compare_as_integer_desc ) );
  group.columns.append( HeaderColumn( "TITLE", HeaderColumn.compare_as_string ) );
  group.columns.append( HeaderColumn( "ARTIST", HeaderColumn.compare_as_string ) );
  group.columns.append( ParentsParentDirectoryColumn() );
  group.columns.append( FullPathColumn() );
  ::Searcher.column_groups.append( group );
}


// ----- SearchMethod ֘A -----------------------------------------------
::Searcher.search_methods.append( BmsAllSearchMethod() );
::Searcher.search_methods.append( MostPlaylevelSearchMethod() );

